/*	engine_position_isrs.c

	Copyright 2008 Fred Cooke

	This file is part of the FreeEMS project.

	FreeEMS software is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FreeEMS software is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with any FreeEMS software.  If not, see <http://www.gnu.org/licenses/>.

	We ask that if you make any changes to this file you send them upstream to us at admin@diyefi.org

	Thank you for choosing FreeEMS to run your engine! */

#include "engine_position_isrs.h"

/* Summary of intended engine position capture scheme
 * 
 * TODO
 * 
 * 
 */

void PrimaryRPMISR(void)
{
	TFLG1 = 0x01;
	
	// echo input condition to output LED adjacent on JimStim
	if(PORTT & 0x01){
		PORTJ &= 0x7F;
		// increment crank pulses
		primaryPulsesPerSecondaryPulse += 1;
		
		/* This code does not work, if you know why, by all means share :-) */
		timeBetweenSuccessivePrimaryPulses = lastPrimaryPulseTimeStamp - TC0;
		timeBetweenSuccessivePrimaryPulsesBuffer = (timeBetweenSuccessivePrimaryPulses >> 1) + (timeBetweenSuccessivePrimaryPulsesBuffer >> 1);
		PORTB = (char)(timeBetweenSuccessivePrimaryPulses >> 8);
	}else{
		PORTJ |= 0x80;
	}

	// suss out rpm and accurate TDC reference
	
	// if you say it quick, it doesn't sound like much :
	// schedule fuel and ign based on spark cut and fuel cut and timing vars and status vars config vars
}

void SecondaryRPMISR(void)
{

	TFLG1 = 0x02;
	
	// echo input condition to output LED adjacent on JimStim
	if(PORTT & 0x02){
		PORTJ &= 0xBF;
		// display the crank pulses before resetting.
		PORTM = (char)primaryPulsesPerSecondaryPulse;
		/* reset the */ 
		primaryPulsesPerSecondaryPulseBuffer = primaryPulsesPerSecondaryPulse;
		primaryPulsesPerSecondaryPulse = 0;
		// TCNT = ZEROS16; // TODO this does not work, how to reset it?
	}else{
		PORTJ |= 0x40;
	}

	// suss out phase/engine cycle reference showing which bank we are on
}
