/*	utils.c

	Copyright 2008 Fred Cooke

	This file is part of the FreeEMS project.

	FreeEMS software is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FreeEMS software is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with any FreeEMS software.  If not, see <http://www.gnu.org/licenses/>.

	We ask that if you make any changes to this file you send them upstream to us at admin@diyefi.org

	Thank you for choosing FreeEMS to run your engine! */

#include "utils.h"

/* Loop repeatedly for a milli second. */
void sleep(int ms)
{
	int j, k, loop;
	loop = ms * 2;

	for(j=0;j<loop;j++)
		for(k=0;k<2857;k++);
}

/* Read two ADC inputs and use them to sleep anywhere from 0.001ms to 1 second */
void sleep2()
{
	// Initial sample for external loop
	int adc3raw = ATD0DR3 + 1; // O2 pot
	int period1 = 2048 / adc3raw;

	int j, k;

	// external loop
	for(j=0;j<period1;j++){
		// Sample ADC for internal loop as we need it
		int adc2raw = ATD0DR2 + 1; // TPS pot
		int period2 = 2048 / adc2raw;
		
		// internal loop
		for(k=0;k<period2;k++);
		
		// Re-sample ADC for external loop as we need it
		adc3raw = ATD0DR3 + 1;
		period1 = 2048 / adc3raw;
	}
}
